#
# keyviewer.py
#
# Copyright (c) 2005 Nokia. All rights reserved.
#
from socket import *
from graphics import *
from appuifw import *
import appuifw
import graphics
import e32


keyboard_state={}
last_keycode=0
last_scancode=-1
fd=-1
pending = 0
current = ''

#ATHLON = '00:02:C7:EA:06:B0'
ATHLON = '00:0D:88:8E:9E:17'
#ATHLON = '00:09:DD:50:1A:3E'
port = 4



def draw_state():
    global fd, keyboard_state, last_scancode, pending
    global bg, current

    canvas.clear()
    canvas.blit (bg)
    #canvas.text((0,12),u'PRISCILA CONTROL',0x008000)

    if pending == 0 :
	return

    if keyboard_state[15] == 1:
	fd.send (u'next\n') 
	canvas.text((0,64),u'CMD: next')
	keyboard_state[15] = 0
	keyboard_state[14] = 0	
        #current = fd.recv (1024)	
    elif keyboard_state[14] == 1:
	fd.send(u'prev\n')
	canvas.text((0,64),u'CMD: prev')
	keyboard_state[14] = 0
	keyboard_state[15] = 0
        #current = fd.recv (1024)

    #canvas.text((0,36),u' '.join([unicode(hex(k)) for k in keyboard_state if keyboard_state[k]]))
    #canvas.text((140,12),u'DONE',0x000080)
    canvas.text((0,76),u'DONE', 0x000080)

    canvas.text((0,100), u'CURRENT:', 0x000000)
    canvas.text((10,112), u'%s'%(current), 0x008000)
    current = ''
    last_scancode = -1
    pending = 0
    e32.ao_sleep(0.1)

    
def callback(event):
    global last_keycode
    global last_scancode, pending

#    e32.ao_sleep(0.1)
    last_scancode = event['scancode']
    if event['type'] == appuifw.EEventKeyDown:
        keyboard_state[event['scancode']]=1
    elif event['type'] == appuifw.EEventKeyUp:
        keyboard_state[event['scancode']]=0
    elif event['type'] == appuifw.EEventKey:
        last_keycode=event['keycode']
    pending = 1
    draw_state()


fd = socket(AF_BT, SOCK_STREAM, BTPROTO_RFCOMM)
target = (ATHLON, port)
fd.connect(target)

#fd.send (u'??')
#current = fd.recv (1024)

canvas=appuifw.Canvas(event_callback=callback,
                      redraw_callback=lambda rect:draw_state())



appuifw.app.screen='full'
appuifw.app.body=canvas

bg = Image.open ('E:\\Images\\bt-logo.jpg')

keyboard_state[14] = 0
keyboard_state[15] = 0	
pending=1
draw_state()


lock=e32.Ao_lock()
appuifw.app.exit_key_handler=lock.signal
lock.wait()
